import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

import javax.microedition.media.*;
import javax.microedition.media.control.*;
import java.io.*;


public final class applet extends MIDlet implements CommandListener {

	mycanvas canvas;
	private static Command cmdExit = new Command("Exit", Command.EXIT,1);
	private static Display display;

	/* ----------------------------------------------------------------------*/
	public applet() {
		display = Display.getDisplay(this);
		canvas = new mycanvas();

		canvas.addCommand(cmdExit);
		canvas.setCommandListener(this);

		display.setCurrent( canvas );
	}
	
	/* ----------------------------------------------------------------------*/
	public void startApp() {
	}

	/* ----------------------------------------------------------------------*/
	public void pauseApp() {
	}

	/* ----------------------------------------------------------------------*/
	public void destroyApp( boolean flag ) {
		canvas = null;
	}

	/* ----------------------------------------------------------------------*/
	public void commandAction(Command c, Displayable d) {
		try {
			destroyApp(true);
			notifyDestroyed();
		} catch ( Exception e) {}
	}
	
}


class mycanvas extends Canvas implements PlayerListener {

	private Player playerBGM;
	VolumeControl vc;
	String errString;
	String listnerString;

	mycanvas() {
		InputStream in = getClass().getResourceAsStream("bgm.mid");
		try {
			playerBGM = Manager.createPlayer( in, "audio/midi" );
			playerBGM.addPlayerListener(this);
		} catch (Exception e) {}
		playerBGM.setLoopCount(-1);
	}
	
	/* ----------------------------------------------------------------------*/
    public void paint( Graphics g ) {
		int yy = 0;
		int fontHeight = Font.getDefaultFont().getHeight();
		g.setColor( 255, 255, 255 );
		g.fillRect( 0, 0, getWidth(), getHeight() );

		g.setColor( 0, 0, 0 );
		g.drawString( "1:realize()", 0, yy, g.TOP|g.LEFT);
		g.drawString( "2:prefetch()", 0, yy+=fontHeight, g.TOP|g.LEFT);
		g.drawString( "3:start()", 0, yy+=fontHeight, g.TOP|g.LEFT);
		g.drawString( "4:stop()", 0, yy+=fontHeight, g.TOP|g.LEFT);
		g.drawString( "5:close()", 0, yy+=fontHeight, g.TOP|g.LEFT);
		g.drawString( "6:volUp()", 0, yy+=fontHeight, g.TOP|g.LEFT);
		g.drawString( "7:volDonw()", 0, yy+=fontHeight, g.TOP|g.LEFT);
		g.drawString( "command result:"+errString, 0, yy+=fontHeight, g.TOP|g.LEFT);
		g.drawString( "listner result:"+listnerString, 0, yy+=fontHeight, g.TOP|g.LEFT);

		switch( playerBGM.getState() ) {
			case Player.CLOSED:
				g.drawString( "CLOSED", 0, yy+=fontHeight, g.TOP|g.LEFT);
				break;
			case Player.REALIZED:
				g.drawString( "REALIZED", 0, yy+=fontHeight, g.TOP|g.LEFT);
				break;
			case Player.PREFETCHED:
				g.drawString( "PREFETCHED", 0, yy+=fontHeight, g.TOP|g.LEFT);
				break;
			case Player.STARTED:
				g.drawString( "STARTED", 0, yy+=fontHeight, g.TOP|g.LEFT);
				break;
			case Player.UNREALIZED:
				g.drawString( "UNREALIZED", 0, yy+=fontHeight, g.TOP|g.LEFT);
				break;
			default:
				g.drawString( "???", 0, yy+=fontHeight, g.TOP|g.LEFT);
				break;
		}
	}

	/* ----------------------------------------------------------------------*/
	public void playerUpdate( Player player, String event, Object eventData ) {
		repaint();
		listnerString = event;
	}
	
	/* ----------------------------------------------------------------------*/
    public void keyPressed( int keycode ) {
		errString = "no error";
		try {
	        switch ( keycode ) {
				case KEY_NUM1:
					playerBGM.realize();
					break;

				case KEY_NUM2:
					playerBGM.prefetch();
					break;

				case KEY_NUM3:
					playerBGM.start();
					break;

				case KEY_NUM4:
					playerBGM.stop();
					break;

				case KEY_NUM5:
					playerBGM.close();
					break;

				case KEY_NUM6:
					vc = (VolumeControl)playerBGM.getControl( "VolumeControl" );
					vc.setLevel(vc.getLevel()+1);
					break;

				case KEY_NUM7:
					vc = (VolumeControl)playerBGM.getControl( "VolumeControl" );
					vc.setLevel(vc.getLevel()-1);
					break;

				default:
					break;
			}
		} catch( Exception e ) {
			errString = e.toString();
		}
		listnerString = "";
		repaint();
	}
}
